package gregtech.common;

import gregtech.api.world.GT_Worldgen_Constants;
import net.minecraft.block.Block;
import net.minecraft.block.state.IBlockState;
import net.minecraft.util.math.BlockPos;
import net.minecraft.util.math.MathHelper;
import net.minecraft.world.World;
import net.minecraft.world.gen.feature.WorldGenerator;

import java.util.Random;

public class GT_MinableOreGenerator
        extends WorldGenerator {

    private Block minableBlockId;
    private Block mBlock;
    private int minableBlockMeta = 0;
    private int numberOfBlocks;
    private boolean allowVoid = false;

    public GT_MinableOreGenerator(Block par1, int par2) {
        this.minableBlockId = par1;
        this.numberOfBlocks = par2;
    }

    public GT_MinableOreGenerator(Block id, int meta, int number, boolean aAllowVoid, Block aBlock) {
        this(id, number);
        this.minableBlockMeta = meta;
        this.allowVoid = aAllowVoid;
        this.mBlock = aBlock;
    }

    public boolean func_180709_b(World par1World, Random par2Random, BlockPos pos) {
        float var6 = par2Random.nextFloat() * 3.141593F;
        int par3 = pos.func_177958_n(), par4 = pos.func_177956_o(), par5 = pos.func_177952_p();
        double var7 = par3 + 8 + MathHelper.func_76126_a(var6) * this.numberOfBlocks / 8.0F;
        double var9 = par3 + 8 - MathHelper.func_76126_a(var6) * this.numberOfBlocks / 8.0F;
        double var11 = par5 + 8 + MathHelper.func_76134_b(var6) * this.numberOfBlocks / 8.0F;
        double var13 = par5 + 8 - MathHelper.func_76134_b(var6) * this.numberOfBlocks / 8.0F;
        double var15 = par4 + par2Random.nextInt(3) - 2;
        double var17 = par4 + par2Random.nextInt(3) - 2;
        for (int var19 = 0; var19 <= this.numberOfBlocks; var19++) {
            double var20 = var7 + (var9 - var7) * var19 / this.numberOfBlocks;
            double var22 = var15 + (var17 - var15) * var19 / this.numberOfBlocks;
            double var24 = var11 + (var13 - var11) * var19 / this.numberOfBlocks;
            double var26 = par2Random.nextDouble() * this.numberOfBlocks / 16.0D;
            double var28 = (MathHelper.func_76126_a(var19 * 3.141593F / this.numberOfBlocks) + 1.0F) * var26 + 1.0D;
            double var30 = (MathHelper.func_76126_a(var19 * 3.141593F / this.numberOfBlocks) + 1.0F) * var26 + 1.0D;
            int var32 = MathHelper.func_76128_c(var20 - var28 / 2.0D);
            int var33 = MathHelper.func_76128_c(var22 - var30 / 2.0D);
            int var34 = MathHelper.func_76128_c(var24 - var28 / 2.0D);
            int var35 = MathHelper.func_76128_c(var20 + var28 / 2.0D);
            int var36 = MathHelper.func_76128_c(var22 + var30 / 2.0D);
            int var37 = MathHelper.func_76128_c(var24 + var28 / 2.0D);
            for (int var38 = var32; var38 <= var35; var38++) {
                double var39 = (var38 + 0.5D - var20) / (var28 / 2.0D);
                if (var39 * var39 < 1.0D) {
                    for (int var41 = var33; var41 <= var36; var41++) {
                        double var42 = (var41 + 0.5D - var22) / (var30 / 2.0D);
                        if (var39 * var39 + var42 * var42 < 1.0D) {
                            for (int var44 = var34; var44 <= var37; var44++) {
                                double var45 = (var44 + 0.5D - var24) / (var28 / 2.0D);
                                BlockPos block = new BlockPos(var38, var41, var44);
                                IBlockState blockState = par1World.func_180495_p(block);
                                if ((var39 * var39 + var42 * var42 + var45 * var45 < 1.0D) && ((this.allowVoid && par1World.func_175623_d(block)) ||
                                        (block != null && (blockState.func_177230_c().isReplaceableOreGen(blockState, par1World, pos, GT_Worldgen_Constants.ANY))))) {
                                    par1World.func_175656_a(block, this.minableBlockId.func_176203_a(minableBlockMeta));
                                }
                            }
                        }
                    }
                }
            }
        }
        return true;
    }
}
