package gregtech.common;

import gregtech.api.world.GT_Worldgen_Ore;
import gregtech.api.world.GT_Worldgen_Constants;
import gregtech.common.blocks.GT_Block_GeneratedOres;
import net.minecraft.block.Block;
import net.minecraft.block.state.IBlockState;
import net.minecraft.util.math.BlockPos;
import net.minecraft.util.math.MathHelper;
import net.minecraft.world.World;
import net.minecraft.world.chunk.IChunkGenerator;
import net.minecraft.world.chunk.IChunkProvider;

import java.util.Collection;
import java.util.Random;

public class GT_Worldgen_Stone
        extends GT_Worldgen_Ore {
    public GT_Worldgen_Stone(String aName, boolean aDefault, Block aBlock, int aBlockMeta, int aDimensionType, int aAmount, int aSize, int aProbability, int aMinY, int aMaxY, Collection<String> aBiomeList, boolean aAllowToGenerateinVoid) {
        super(aName, aDefault, aBlock, aBlockMeta, aDimensionType, aAmount, aSize, aProbability, aMinY, aMaxY, aBiomeList, aAllowToGenerateinVoid);
    }
    
    private BlockPos.MutableBlockPos temp = new BlockPos.MutableBlockPos();

    @Override
    public boolean executeWorldgen(World aWorld, Random aRandom, String aBiome, int aDimensionType, int aChunkX, int aChunkZ, IChunkGenerator aChunkGenerator, IChunkProvider aChunkProvider) {
        if ((isDimensionAllowed(aWorld, aDimensionType, this.mDimensionType)) && ((this.mBiomeList.isEmpty()) || (this.mBiomeList.contains(aBiome))) && ((this.mProbability <= 1) || (aRandom.nextInt(this.mProbability) == 0))) {
            for (int i = 0; i < this.mAmount; i++) {
                int tX = aChunkX + aRandom.nextInt(16);
                int tY = this.mMinY + aRandom.nextInt(this.mMaxY - this.mMinY);
                int tZ = aChunkZ + aRandom.nextInt(16);
                temp.func_181079_c(tX, tY, tZ);
                if ((this.mAllowToGenerateinVoid) || !aWorld.func_175623_d(temp)) {
                    float var6 = aRandom.nextFloat() * 3.141593F;
                    double var7 = tX + 8 + MathHelper.func_76126_a(var6) * this.mSize / 8.0F;
                    double var9 = tX + 8 - MathHelper.func_76126_a(var6) * this.mSize / 8.0F;
                    double var11 = tZ + 8 + MathHelper.func_76134_b(var6) * this.mSize / 8.0F;
                    double var13 = tZ + 8 - MathHelper.func_76134_b(var6) * this.mSize / 8.0F;
                    double var15 = tY + aRandom.nextInt(3) - 2;
                    double var17 = tY + aRandom.nextInt(3) - 2;
                    for (int var19 = 0; var19 <= this.mSize; var19++) {
                        double var20 = var7 + (var9 - var7) * var19 / this.mSize;
                        double var22 = var15 + (var17 - var15) * var19 / this.mSize;
                        double var24 = var11 + (var13 - var11) * var19 / this.mSize;
                        double var26 = aRandom.nextDouble() * this.mSize / 16.0D;
                        double var28 = (MathHelper.func_76126_a(var19 * 3.141593F / this.mSize) + 1.0F) * var26 + 1.0D;
                        double var30 = (MathHelper.func_76126_a(var19 * 3.141593F / this.mSize) + 1.0F) * var26 + 1.0D;
                        int tMinX = MathHelper.func_76128_c(var20 - var28 / 2.0D);
                        int tMinY = MathHelper.func_76128_c(var22 - var30 / 2.0D);
                        int tMinZ = MathHelper.func_76128_c(var24 - var28 / 2.0D);
                        int tMaxX = MathHelper.func_76128_c(var20 + var28 / 2.0D);
                        int tMaxY = MathHelper.func_76128_c(var22 + var30 / 2.0D);
                        int tMaxZ = MathHelper.func_76128_c(var24 + var28 / 2.0D);
                        for (int eX = tMinX; eX <= tMaxX; eX++) {
                            double var39 = (eX + 0.5D - var20) / (var28 / 2.0D);
                            if (var39 * var39 < 1.0D) {
                                for (int eY = tMinY; eY <= tMaxY; eY++) {
                                    double var42 = (eY + 0.5D - var22) / (var30 / 2.0D);
                                    if (var39 * var39 + var42 * var42 < 1.0D) {
                                        for (int eZ = tMinZ; eZ <= tMaxZ; eZ++) {
                                            double var45 = (eZ + 0.5D - var24) / (var28 / 2.0D);
                                            if (var39 * var39 + var42 * var42 + var45 * var45 < 1.0D) {
                                                temp.func_181079_c(eX, eY, eZ);
                                                IBlockState tTargetedBlock = aWorld.func_180495_p(temp);
                                                if (tTargetedBlock.func_177230_c() instanceof GT_Block_GeneratedOres) {

                                                } else if ((this.mAllowToGenerateinVoid && aWorld.func_175623_d(temp)) ||
                                                        (tTargetedBlock != null && tTargetedBlock.func_177230_c().isReplaceableOreGen(tTargetedBlock, aWorld, temp, GT_Worldgen_Constants.ANY))) {
                                                    aWorld.func_175656_a(temp, this.mBlock.func_176203_a(mBlockMeta));
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
            return true;
        }
        return false;
    }
}
