package gregtech.common.blocks;

import gregtech.api.enums.ItemList;
import gregtech.api.enums.Textures;
import gregtech.api.interfaces.IIconContainer;
import gregtech.api.util.GT_LanguageManager;
import net.minecraft.client.renderer.texture.TextureAtlasSprite;
import net.minecraft.item.ItemStack;
import net.minecraft.util.EnumFacing;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;

public class GT_Block_Casings5 extends GT_Block_Casings_Abstract {

    public GT_Block_Casings5() {
        super(GT_Item_Casings5.class, "gt.blockcasings5", GT_Material_Casings.INSTANCE);

        GT_LanguageManager.addStringLocalization(func_149739_a() + ".0.name", "Cupronickel Coil Block");
        GT_LanguageManager.addStringLocalization(func_149739_a() + ".1.name", "Kanthal Coil Block");
        GT_LanguageManager.addStringLocalization(func_149739_a() + ".2.name", "Nichrome Coil Block");
        GT_LanguageManager.addStringLocalization(func_149739_a() + ".3.name", "Tungstensteel Coil Block");
        GT_LanguageManager.addStringLocalization(func_149739_a() + ".4.name", "HSS-G Coil Block");
        GT_LanguageManager.addStringLocalization(func_149739_a() + ".5.name", "Naquadah Coil Block");
        GT_LanguageManager.addStringLocalization(func_149739_a() + ".6.name", "Naquadah Alloy Coil Block");

        ItemList.Casing_Coil_Cupronickel.set(new ItemStack(this, 1, 0));
        ItemList.Casing_Coil_Kanthal.set(new ItemStack(this, 1, 1));
        ItemList.Casing_Coil_Nichrome.set(new ItemStack(this, 1, 2));
        ItemList.Casing_Coil_TungstenSteel.set(new ItemStack(this, 1, 3));
        ItemList.Casing_Coil_HSSG.set(new ItemStack(this, 1, 4));
        ItemList.Casing_Coil_Naquadah.set(new ItemStack(this, 1, 5));
        ItemList.Casing_Coil_NaquadahAlloy.set(new ItemStack(this, 1, 6));
    }
    @Override
    @SideOnly(Side.CLIENT)
    public TextureAtlasSprite getIcon(EnumFacing aSide, int aMeta) {
        return getIconContainer(aSide, aMeta).getIcon();
    }
    
    public static IIconContainer getIconContainer(EnumFacing aSide, int aMeta) {
        switch (aMeta) {
            case 0:
                return Textures.BlockIcons.MACHINE_COIL_CUPRONICKEL;
            case 1:
                return Textures.BlockIcons.MACHINE_COIL_KANTHAL;
            case 2:
                return Textures.BlockIcons.MACHINE_COIL_NICHROME;
            case 3:
                return Textures.BlockIcons.MACHINE_COIL_TUNGSTENSTEEL;
            case 4:
                return Textures.BlockIcons.MACHINE_COIL_HSSG;
            case 5:
                return Textures.BlockIcons.MACHINE_COIL_NAQUADAH;
            case 6:
                return Textures.BlockIcons.MACHINE_COIL_NAQUADAHALLOY;
        }
        return Textures.BlockIcons.MACHINE_COIL_CUPRONICKEL;
    }
    
}
