package gregtech.common.entities;

import net.minecraft.entity.EntityLivingBase;
import net.minecraft.entity.projectile.EntityArrow;
import net.minecraft.item.ItemStack;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.world.World;

import net.minecraft.entity.projectile.EntityArrow.PickupStatus;

public class GT_Entity_Arrow extends EntityArrow {

    private ItemStack arrowStack;

    public GT_Entity_Arrow(World worldIn) {
        super(worldIn);
    }

    public GT_Entity_Arrow(World worldIn, double x, double y, double z, ItemStack arrowStack) {
        super(worldIn, x, y, z);
        this.arrowStack = arrowStack;
    }

    public GT_Entity_Arrow(World worldIn, EntityLivingBase shooter, ItemStack arrowStack) {
        super(worldIn, shooter);
        this.arrowStack = arrowStack;
    }

    @Override
    public void func_70014_b(NBTTagCompound compound) {
        super.func_70014_b(compound);
        if(arrowStack != null) {
            compound.func_74782_a("Item", arrowStack.func_77955_b(new NBTTagCompound()));
        }
    }

    @Override
    public void func_70037_a(NBTTagCompound compound) {
        super.func_70037_a(compound);
        if(compound.func_74764_b("Item")) {
            arrowStack = ItemStack.func_77949_a(compound.func_74775_l("Item"));
        }
    }

    public void setPickup(PickupStatus pickup) {
        field_70251_a = pickup;
    }

    public void setArrowStack(ItemStack arrowStack) {
        this.arrowStack = arrowStack;
    }

    @Override
    protected ItemStack func_184550_j() {
        return arrowStack;
    }

}
