package gregtech.common.render;

import net.minecraft.client.Minecraft;
import net.minecraft.client.renderer.block.model.ItemCameraTransforms;
import net.minecraft.client.renderer.block.model.ModelBlock;
import net.minecraft.client.resources.IResource;
import net.minecraft.util.ResourceLocation;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;

import java.io.IOException;
import java.io.InputStreamReader;

/**
 * Simple util for gathering transforms from external model jsons
 */
@SideOnly(Side.CLIENT)
public class ModelUtil {

    public static ItemCameraTransforms DEFAULT_TRANSFORMS = getTransformsFromModel("models/item/generated.json");
    public static ItemCameraTransforms HANDHELD_TRANSFORMS = getTransformsFromModel("models/item/handheld.json");
    public static ItemCameraTransforms BLOCK_TRANSFORMS = getTransformsFromModel("models/block/block.json");

    public static ItemCameraTransforms getTransformsFromModel(String path) {
        try {
            ResourceLocation location = new ResourceLocation(path);
            IResource resource = Minecraft.func_71410_x().func_110442_L().func_110536_a(location);
            try (InputStreamReader reader = new InputStreamReader(resource.func_110527_b())) {
                ModelBlock modelBlock = ModelBlock.func_178307_a(reader);
                return modelBlock.func_181682_g();
            }
        } catch (IOException notFound) {}
        return ItemCameraTransforms.field_178357_a;
    }

}
